
# PaymentRefund

### Description

Represents a refund of a payment made using Square. Contains information on the original payment and the amount of money refunded.

## Properties
Name | Type | Description | Notes
------------ | ------------- | ------------- | -------------
**id** | **String** | Unique ID for this refund, generated by Square. | 
**status** | **String** | The refund&#39;s status: - &#x60;PENDING&#x60; - awaiting approval - &#x60;COMPLETED&#x60; - successfully completed - &#x60;REJECTED&#x60; - the refund was rejected - &#x60;FAILED&#x60; - an error occurred |  [optional]
**locationId** | **String** | Location ID associated with the payment this refund is attached to. |  [optional]
**amountMoney** | [**Money**](Money.md) | The amount of money refunded, specified in the smallest denomination of the applicable currency. For example, US dollar amounts are specified in cents. | 
**appFeeMoney** | [**Money**](Money.md) | Amount of money the app developer contributed to help cover the refunded amount. Specified in the smallest denomination of the applicable currency. For example, US dollar amounts are specified in cents. See [Working with monetary amounts](/build-basics/working-with-monetary-amounts) for details. |  [optional]
**processingFee** | [**List&lt;ProcessingFee&gt;**](ProcessingFee.md) | Processing fees and fee adjustments assessed by Square on this refund. |  [optional]
**paymentId** | **String** | The ID of the payment assocated with this refund. |  [optional]
**orderId** | **String** | The ID of the order associated with the refund. |  [optional]
**reason** | **String** | The reason for the refund. |  [optional]
**createdAt** | **String** | Timestamp of when the refund was created, in RFC 3339 format. |  [optional]
**updatedAt** | **String** | Timestamp of when the refund was last updated, in RFC 3339 format. |  [optional]



