/*
 * Square Connect API
 * Client library for accessing the Square Connect APIs
 *
 * OpenAPI spec version: 2.0
 * Contact: developers@squareup.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.squareup.connect.models;

import java.util.Objects;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import com.squareup.connect.models.CatalogIdMapping;
import com.squareup.connect.models.CatalogObject;
import com.squareup.connect.models.Error;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.util.ArrayList;
import java.util.List;

/**
 * 
 */
@ApiModel(description = "")

public class BatchUpsertCatalogObjectsResponse {
  @JsonProperty("errors")
  private List<Error> errors = new ArrayList<Error>();

  @JsonProperty("objects")
  private List<CatalogObject> objects = new ArrayList<CatalogObject>();

  @JsonProperty("updated_at")
  private String updatedAt = null;

  @JsonProperty("id_mappings")
  private List<CatalogIdMapping> idMappings = new ArrayList<CatalogIdMapping>();

  public BatchUpsertCatalogObjectsResponse errors(List<Error> errors) {
    this.errors = errors;
    return this;
  }

  public BatchUpsertCatalogObjectsResponse addErrorsItem(Error errorsItem) {
    this.errors.add(errorsItem);
    return this;
  }

   /**
   * The set of [Error](#type-error)s encountered.
   * @return errors
  **/
  @ApiModelProperty(value = "The set of [Error](#type-error)s encountered.")
  public List<Error> getErrors() {
    return errors;
  }

  public void setErrors(List<Error> errors) {
    this.errors = errors;
  }

  public BatchUpsertCatalogObjectsResponse objects(List<CatalogObject> objects) {
    this.objects = objects;
    return this;
  }

  public BatchUpsertCatalogObjectsResponse addObjectsItem(CatalogObject objectsItem) {
    this.objects.add(objectsItem);
    return this;
  }

   /**
   * The created [CatalogObject](#type-catalogobject)s
   * @return objects
  **/
  @ApiModelProperty(value = "The created [CatalogObject](#type-catalogobject)s")
  public List<CatalogObject> getObjects() {
    return objects;
  }

  public void setObjects(List<CatalogObject> objects) {
    this.objects = objects;
  }

  public BatchUpsertCatalogObjectsResponse updatedAt(String updatedAt) {
    this.updatedAt = updatedAt;
    return this;
  }

   /**
   * The database [timestamp](#workingwithdates) of this update in RFC 3339 format, e.g., \"2016-09-04T23:59:33.123Z\".
   * @return updatedAt
  **/
  @ApiModelProperty(value = "The database [timestamp](#workingwithdates) of this update in RFC 3339 format, e.g., \"2016-09-04T23:59:33.123Z\".")
  public String getUpdatedAt() {
    return updatedAt;
  }

  public void setUpdatedAt(String updatedAt) {
    this.updatedAt = updatedAt;
  }

  public BatchUpsertCatalogObjectsResponse idMappings(List<CatalogIdMapping> idMappings) {
    this.idMappings = idMappings;
    return this;
  }

  public BatchUpsertCatalogObjectsResponse addIdMappingsItem(CatalogIdMapping idMappingsItem) {
    this.idMappings.add(idMappingsItem);
    return this;
  }

   /**
   * The mapping between client and server IDs for this Upsert.
   * @return idMappings
  **/
  @ApiModelProperty(value = "The mapping between client and server IDs for this Upsert.")
  public List<CatalogIdMapping> getIdMappings() {
    return idMappings;
  }

  public void setIdMappings(List<CatalogIdMapping> idMappings) {
    this.idMappings = idMappings;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    BatchUpsertCatalogObjectsResponse batchUpsertCatalogObjectsResponse = (BatchUpsertCatalogObjectsResponse) o;
    return Objects.equals(this.errors, batchUpsertCatalogObjectsResponse.errors) &&
        Objects.equals(this.objects, batchUpsertCatalogObjectsResponse.objects) &&
        Objects.equals(this.updatedAt, batchUpsertCatalogObjectsResponse.updatedAt) &&
        Objects.equals(this.idMappings, batchUpsertCatalogObjectsResponse.idMappings);
  }

  @Override
  public int hashCode() {
    return Objects.hash(errors, objects, updatedAt, idMappings);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class BatchUpsertCatalogObjectsResponse {\n");
    
    sb.append("    errors: ").append(toIndentedString(errors)).append("\n");
    sb.append("    objects: ").append(toIndentedString(objects)).append("\n");
    sb.append("    updatedAt: ").append(toIndentedString(updatedAt)).append("\n");
    sb.append("    idMappings: ").append(toIndentedString(idMappings)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
  
}

