/*
 * Square Connect API
 * Client library for accessing the Square Connect APIs
 *
 * OpenAPI spec version: 2.0
 * Contact: developers@squareup.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.squareup.connect.models;

import java.util.Objects;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

/**
 * An enumerated value that can link a [CatalogItemVariation(#type-catalogitemvariation) to an item option as one of its item option values.
 */
@ApiModel(description = "An enumerated value that can link a [CatalogItemVariation(#type-catalogitemvariation) to an item option as one of its item option values.")

public class CatalogItemOptionValue {
  @JsonProperty("item_option_id")
  private String itemOptionId = null;

  @JsonProperty("name")
  private String name = null;

  @JsonProperty("description")
  private String description = null;

  @JsonProperty("color")
  private String color = null;

  @JsonProperty("ordinal")
  private Integer ordinal = null;

  @JsonProperty("item_variation_count")
  private Long itemVariationCount = null;

  public CatalogItemOptionValue itemOptionId(String itemOptionId) {
    this.itemOptionId = itemOptionId;
    return this;
  }

   /**
   * Unique ID of the associated item option.
   * @return itemOptionId
  **/
  @ApiModelProperty(value = "Unique ID of the associated item option.")
  public String getItemOptionId() {
    return itemOptionId;
  }

  public void setItemOptionId(String itemOptionId) {
    this.itemOptionId = itemOptionId;
  }

  public CatalogItemOptionValue name(String name) {
    this.name = name;
    return this;
  }

   /**
   * Name of this item option value. Searchable.
   * @return name
  **/
  @ApiModelProperty(value = "Name of this item option value. Searchable.")
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public CatalogItemOptionValue description(String description) {
    this.description = description;
    return this;
  }

   /**
   * The option value's human-readable description.
   * @return description
  **/
  @ApiModelProperty(value = "The option value's human-readable description.")
  public String getDescription() {
    return description;
  }

  public void setDescription(String description) {
    this.description = description;
  }

  public CatalogItemOptionValue color(String color) {
    this.color = color;
    return this;
  }

   /**
   * The HTML color for this value in the format #FFRRGGBB or #RRGGBB (e.g., \"#ff8d4e85\"). Only displayed if parent Item Option's `show_colors` flag is enabled. value.
   * @return color
  **/
  @ApiModelProperty(value = "The HTML color for this value in the format #FFRRGGBB or #RRGGBB (e.g., \"#ff8d4e85\"). Only displayed if parent Item Option's `show_colors` flag is enabled. value.")
  public String getColor() {
    return color;
  }

  public void setColor(String color) {
    this.color = color;
  }

  public CatalogItemOptionValue ordinal(Integer ordinal) {
    this.ordinal = ordinal;
    return this;
  }

   /**
   * Determines where this option value appears in a list of option values.
   * @return ordinal
  **/
  @ApiModelProperty(value = "Determines where this option value appears in a list of option values.")
  public Integer getOrdinal() {
    return ordinal;
  }

  public void setOrdinal(Integer ordinal) {
    this.ordinal = ordinal;
  }

  public CatalogItemOptionValue itemVariationCount(Long itemVariationCount) {
    this.itemVariationCount = itemVariationCount;
    return this;
  }

   /**
   * The number of [CatalogItemVariation(#type-catalogitemvariation)s that currently make use of this Item Option value. Present only if `retrieve_counts` was specified on the request used to retrieve the parent Item Option of this value.  Maximum: 100 counts.
   * @return itemVariationCount
  **/
  @ApiModelProperty(value = "The number of [CatalogItemVariation(#type-catalogitemvariation)s that currently make use of this Item Option value. Present only if `retrieve_counts` was specified on the request used to retrieve the parent Item Option of this value.  Maximum: 100 counts.")
  public Long getItemVariationCount() {
    return itemVariationCount;
  }

  public void setItemVariationCount(Long itemVariationCount) {
    this.itemVariationCount = itemVariationCount;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    CatalogItemOptionValue catalogItemOptionValue = (CatalogItemOptionValue) o;
    return Objects.equals(this.itemOptionId, catalogItemOptionValue.itemOptionId) &&
        Objects.equals(this.name, catalogItemOptionValue.name) &&
        Objects.equals(this.description, catalogItemOptionValue.description) &&
        Objects.equals(this.color, catalogItemOptionValue.color) &&
        Objects.equals(this.ordinal, catalogItemOptionValue.ordinal) &&
        Objects.equals(this.itemVariationCount, catalogItemOptionValue.itemVariationCount);
  }

  @Override
  public int hashCode() {
    return Objects.hash(itemOptionId, name, description, color, ordinal, itemVariationCount);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class CatalogItemOptionValue {\n");
    
    sb.append("    itemOptionId: ").append(toIndentedString(itemOptionId)).append("\n");
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    description: ").append(toIndentedString(description)).append("\n");
    sb.append("    color: ").append(toIndentedString(color)).append("\n");
    sb.append("    ordinal: ").append(toIndentedString(ordinal)).append("\n");
    sb.append("    itemVariationCount: ").append(toIndentedString(itemVariationCount)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
  
}

