/*
 * Square Connect API
 * Client library for accessing the Square Connect APIs
 *
 * OpenAPI spec version: 2.0
 * Contact: developers@squareup.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.squareup.connect.models;

import java.util.Objects;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import com.squareup.connect.models.CustomerFilter;
import com.squareup.connect.models.CustomerSort;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

/**
 * Represents a query (filtering and sorting criteria) used to search for customer profiles.
 */
@ApiModel(description = "Represents a query (filtering and sorting criteria) used to search for customer profiles.")

public class CustomerQuery {
  @JsonProperty("filter")
  private CustomerFilter filter = null;

  @JsonProperty("sort")
  private CustomerSort sort = null;

  public CustomerQuery filter(CustomerFilter filter) {
    this.filter = filter;
    return this;
  }

   /**
   * A list of filter criteria.
   * @return filter
  **/
  @ApiModelProperty(value = "A list of filter criteria.")
  public CustomerFilter getFilter() {
    return filter;
  }

  public void setFilter(CustomerFilter filter) {
    this.filter = filter;
  }

  public CustomerQuery sort(CustomerSort sort) {
    this.sort = sort;
    return this;
  }

   /**
   * Sort criteria for query results. The default sort behavior is to order customers alphabetically by `given_name` and `last_name`.
   * @return sort
  **/
  @ApiModelProperty(value = "Sort criteria for query results. The default sort behavior is to order customers alphabetically by `given_name` and `last_name`.")
  public CustomerSort getSort() {
    return sort;
  }

  public void setSort(CustomerSort sort) {
    this.sort = sort;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    CustomerQuery customerQuery = (CustomerQuery) o;
    return Objects.equals(this.filter, customerQuery.filter) &&
        Objects.equals(this.sort, customerQuery.sort);
  }

  @Override
  public int hashCode() {
    return Objects.hash(filter, sort);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class CustomerQuery {\n");
    
    sb.append("    filter: ").append(toIndentedString(filter)).append("\n");
    sb.append("    sort: ").append(toIndentedString(sort)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
  
}

