/*
 * Square Connect API
 * Client library for accessing the Square Connect APIs
 *
 * OpenAPI spec version: 2.0
 * Contact: developers@squareup.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.squareup.connect.models;

import java.util.Objects;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import com.squareup.connect.models.Money;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

/**
 * A collection of various money amounts.
 */
@ApiModel(description = "A collection of various money amounts.")

public class OrderMoneyAmounts {
  @JsonProperty("total_money")
  private Money totalMoney = null;

  @JsonProperty("tax_money")
  private Money taxMoney = null;

  @JsonProperty("discount_money")
  private Money discountMoney = null;

  @JsonProperty("tip_money")
  private Money tipMoney = null;

  @JsonProperty("service_charge_money")
  private Money serviceChargeMoney = null;

  public OrderMoneyAmounts totalMoney(Money totalMoney) {
    this.totalMoney = totalMoney;
    return this;
  }

   /**
   * Total money.
   * @return totalMoney
  **/
  @ApiModelProperty(value = "Total money.")
  public Money getTotalMoney() {
    return totalMoney;
  }

  public void setTotalMoney(Money totalMoney) {
    this.totalMoney = totalMoney;
  }

  public OrderMoneyAmounts taxMoney(Money taxMoney) {
    this.taxMoney = taxMoney;
    return this;
  }

   /**
   * Money associated with taxes.
   * @return taxMoney
  **/
  @ApiModelProperty(value = "Money associated with taxes.")
  public Money getTaxMoney() {
    return taxMoney;
  }

  public void setTaxMoney(Money taxMoney) {
    this.taxMoney = taxMoney;
  }

  public OrderMoneyAmounts discountMoney(Money discountMoney) {
    this.discountMoney = discountMoney;
    return this;
  }

   /**
   * Money associated with discounts.
   * @return discountMoney
  **/
  @ApiModelProperty(value = "Money associated with discounts.")
  public Money getDiscountMoney() {
    return discountMoney;
  }

  public void setDiscountMoney(Money discountMoney) {
    this.discountMoney = discountMoney;
  }

  public OrderMoneyAmounts tipMoney(Money tipMoney) {
    this.tipMoney = tipMoney;
    return this;
  }

   /**
   * Money associated with tips.
   * @return tipMoney
  **/
  @ApiModelProperty(value = "Money associated with tips.")
  public Money getTipMoney() {
    return tipMoney;
  }

  public void setTipMoney(Money tipMoney) {
    this.tipMoney = tipMoney;
  }

  public OrderMoneyAmounts serviceChargeMoney(Money serviceChargeMoney) {
    this.serviceChargeMoney = serviceChargeMoney;
    return this;
  }

   /**
   * Money associated with service charges.
   * @return serviceChargeMoney
  **/
  @ApiModelProperty(value = "Money associated with service charges.")
  public Money getServiceChargeMoney() {
    return serviceChargeMoney;
  }

  public void setServiceChargeMoney(Money serviceChargeMoney) {
    this.serviceChargeMoney = serviceChargeMoney;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    OrderMoneyAmounts orderMoneyAmounts = (OrderMoneyAmounts) o;
    return Objects.equals(this.totalMoney, orderMoneyAmounts.totalMoney) &&
        Objects.equals(this.taxMoney, orderMoneyAmounts.taxMoney) &&
        Objects.equals(this.discountMoney, orderMoneyAmounts.discountMoney) &&
        Objects.equals(this.tipMoney, orderMoneyAmounts.tipMoney) &&
        Objects.equals(this.serviceChargeMoney, orderMoneyAmounts.serviceChargeMoney);
  }

  @Override
  public int hashCode() {
    return Objects.hash(totalMoney, taxMoney, discountMoney, tipMoney, serviceChargeMoney);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class OrderMoneyAmounts {\n");
    
    sb.append("    totalMoney: ").append(toIndentedString(totalMoney)).append("\n");
    sb.append("    taxMoney: ").append(toIndentedString(taxMoney)).append("\n");
    sb.append("    discountMoney: ").append(toIndentedString(discountMoney)).append("\n");
    sb.append("    tipMoney: ").append(toIndentedString(tipMoney)).append("\n");
    sb.append("    serviceChargeMoney: ").append(toIndentedString(serviceChargeMoney)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
  
}

