/*
 * Square Connect API
 * Client library for accessing the Square Connect APIs
 *
 * OpenAPI spec version: 2.0
 * Contact: developers@squareup.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.squareup.connect.models;

import java.util.Objects;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.util.ArrayList;
import java.util.List;

/**
 * Filter based on order &#x60;source&#x60; information.
 */
@ApiModel(description = "Filter based on order `source` information.")

public class SearchOrdersSourceFilter {
  @JsonProperty("source_names")
  private List<String> sourceNames = new ArrayList<String>();

  public SearchOrdersSourceFilter sourceNames(List<String> sourceNames) {
    this.sourceNames = sourceNames;
    return this;
  }

  public SearchOrdersSourceFilter addSourceNamesItem(String sourceNamesItem) {
    this.sourceNames.add(sourceNamesItem);
    return this;
  }

   /**
   * Filters by [Source](#type-ordersource) `name`. Will return any orders with with a `source.name` that matches any of the listed source names.  Max: 10 source names.
   * @return sourceNames
  **/
  @ApiModelProperty(value = "Filters by [Source](#type-ordersource) `name`. Will return any orders with with a `source.name` that matches any of the listed source names.  Max: 10 source names.")
  public List<String> getSourceNames() {
    return sourceNames;
  }

  public void setSourceNames(List<String> sourceNames) {
    this.sourceNames = sourceNames;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    SearchOrdersSourceFilter searchOrdersSourceFilter = (SearchOrdersSourceFilter) o;
    return Objects.equals(this.sourceNames, searchOrdersSourceFilter.sourceNames);
  }

  @Override
  public int hashCode() {
    return Objects.hash(sourceNames);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class SearchOrdersSourceFilter {\n");
    
    sb.append("    sourceNames: ").append(toIndentedString(sourceNames)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
  
}

