/*
 * Square Connect API
 * Client library for accessing the Square Connect APIs
 *
 * OpenAPI spec version: 2.0
 * Contact: developers@squareup.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package com.squareup.connect.models;

import java.util.Objects;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonValue;
import com.squareup.connect.models.Error;
import com.squareup.connect.models.WorkweekConfig;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.util.ArrayList;
import java.util.List;

/**
 * The response to a request to update a &#x60;WorkweekConfig&#x60; object. Contains the updated &#x60;WorkweekConfig&#x60; object. May contain a set of &#x60;Error&#x60; objects if the request resulted in errors.
 */
@ApiModel(description = "The response to a request to update a `WorkweekConfig` object. Contains the updated `WorkweekConfig` object. May contain a set of `Error` objects if the request resulted in errors.")

public class UpdateWorkweekConfigResponse {
  @JsonProperty("workweek_config")
  private WorkweekConfig workweekConfig = null;

  @JsonProperty("errors")
  private List<Error> errors = new ArrayList<Error>();

  public UpdateWorkweekConfigResponse workweekConfig(WorkweekConfig workweekConfig) {
    this.workweekConfig = workweekConfig;
    return this;
  }

   /**
   * The response object.
   * @return workweekConfig
  **/
  @ApiModelProperty(value = "The response object.")
  public WorkweekConfig getWorkweekConfig() {
    return workweekConfig;
  }

  public void setWorkweekConfig(WorkweekConfig workweekConfig) {
    this.workweekConfig = workweekConfig;
  }

  public UpdateWorkweekConfigResponse errors(List<Error> errors) {
    this.errors = errors;
    return this;
  }

  public UpdateWorkweekConfigResponse addErrorsItem(Error errorsItem) {
    this.errors.add(errorsItem);
    return this;
  }

   /**
   * Any errors that occurred during the request.
   * @return errors
  **/
  @ApiModelProperty(value = "Any errors that occurred during the request.")
  public List<Error> getErrors() {
    return errors;
  }

  public void setErrors(List<Error> errors) {
    this.errors = errors;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    UpdateWorkweekConfigResponse updateWorkweekConfigResponse = (UpdateWorkweekConfigResponse) o;
    return Objects.equals(this.workweekConfig, updateWorkweekConfigResponse.workweekConfig) &&
        Objects.equals(this.errors, updateWorkweekConfigResponse.errors);
  }

  @Override
  public int hashCode() {
    return Objects.hash(workweekConfig, errors);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class UpdateWorkweekConfigResponse {\n");
    
    sb.append("    workweekConfig: ").append(toIndentedString(workweekConfig)).append("\n");
    sb.append("    errors: ").append(toIndentedString(errors)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }
  
}

